/*****************************************************************************
* Copyright (c) 1990-98 Digi International Inc., All Rights Reserved
* 
* This software contains proprietary and confidential information of Digi
* International Inc.  By accepting transfer of this copy, Recipient agrees
* to retain this software in confidence, to prevent disclosure to others,
* and to make no use of this software other than that for which it was
* delivered.  This is an unpublished copyrighted work of Digi International
* Inc.  Except as permitted by federal law, 17 USC 117, copying is strictly
* prohibited.
* 
* Restricted Rights Legend
*
* Use, duplication, or disclosure by the Government is subject to
* restrictions set forth in sub-paragraph (c)(1)(ii) of The Rights in
* Technical Data and Computer Software clause at DFARS 252.227-7031 or
* subparagraphs (c)(1) and (2) of the Commercial Computer Software -
* Restricted Rights at 48 CFR 52.227-19, as applicable.
*
* Digi International Inc. 11001 Bren Road East, Minnetonka, MN 55343
*
*****************************************************************************/


// ProtocolT1.h: interface for the CProtocolT1 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROTOCOLT1_H__EFF29714_C980_11D1_BAAC_00805F9E3135__INCLUDED_)
#define AFX_PROTOCOLT1_H__EFF29714_C980_11D1_BAAC_00805F9E3135__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Protocol.h"
#include "DS1Config.h"
#include "ValueMap.h"
#include "WizPageRadioButtons.h"
#include "WizPageComboBox.h"

class PROTOCOL_EXPORTED_CLASS CProtocolT1 : public CProtocol
{
	DECLARE_DYNAMIC(CProtocolT1)

public:
	CProtocolT1(HKEY const hKeyRoot, CString const strRegPath, CConfigObject const * const pParent);
	virtual ~CProtocolT1();

   virtual BOOL AddChild(void);
           BOOL AddChild(CString const & strChild);

   virtual BOOL SetParameters(void);
   virtual BOOL RemoveParameters(BOOL fRemoveKey = FALSE);
   virtual BOOL CopyParameters(CConfigObject const * const pFrom);

   virtual BOOL AddWizardPages(CConfigWizSheet * const pSheet);
   virtual BOOL RemoveWizardPages(CConfigWizSheet * const pSheet);
   virtual BOOL NextWizardPage(int const nState);

   virtual CString GetInformationText(void);

   virtual BOOL DoProperties(void);

private:
   //
   // Parameters gettable/settable by the config (data resides in adapter instance registry key)
   SDS1Config m_DS1Config;

   BOOL GetParameters(void);
   BOOL GetConfigData(void);

   //
   // Wizard stuff
   CConfigWizSheet * m_pwsSheet;

   enum
   {
      WP_UNKNOWN = -1,
      WP_SIGNALING,
      WP_WINKDIGITS,
      WP_COUNT
   };

   SValueMap m_SignalingValueMap;
   SValueMap m_WinkDigitsValueMap;

   CWizPageRadioButtons * m_pSignalingWizPage;
   CWizPageSpin * m_pWinkDigitsWizPage;

   BOOL HandleWizSignaling(void);
   BOOL HandleWizWinkDigits(void);
};

#endif // !defined(AFX_PROTOCOLT1_H__EFF29714_C980_11D1_BAAC_00805F9E3135__INCLUDED_)
